searchNodes=[{"doc":"This library wraps Erlang/OTP's SSH daemon to make it easier to use reliably with Nerves devices. Most importantly, it makes it possible to segment failures in other OTP applications from terminating the daemon and it recovers from rare scenarios where the daemon terminates without automatically restarting. It can be started automatically as an OTP application or hooked into a supervision tree of your creation. Most Nerves users start it automatically as an OTP application. This is easy, but may be limiting and it requires that you use the application environment. See the following sections for options: Starting as an OTP application If you're using :nerves_pack v0.4.0 or later, you don't need to do anything except verify the :nerves_ssh configuration in your config.exs (see below). If you are not using :nerves_pack , add :nerves_ssh to your mix dependency list: def deps do [ { :nerves_ssh , &quot;~&gt; 0.1.0&quot; , targets : @all_targets } ] end And then include it in :shoehorn 's :init list: config :shoehorn , init : [ :nerves_runtime , :vintage_net , :nerves_ssh ] :nerves_ssh will work if you do not add it to the :init list. However, if your main OTP application stops, OTP may stop :nerves_ssh , and that would make your device inaccessible via SSH. Starting as part of one of your supervision trees If you want to do this, make sure that you do NOT specify :nerves_ssh in your config.exs . The :nerves_ssh key decides whether or not to automatically launch based on this. Then when specifying the children for your supervisor, add NervesSSH like this: { NervesSSH , nerves_ssh_options } The nerves_ssh_options should be a NervesSSH.Options struct. See the Configuration section option fields that you may specify. Calling NervesSSH.Options.with_defaults(my_options_list) to build the nerves_ssh_options value is one way of getting reasonable defaults. Configuration NervesSSH supports the following configuration items: :authorized_keys - a list of SSH authorized key file string :user_passwords - a list of username/password tuples (stored in the clear!) :port - the TCP port to use for the SSH daemon. Defaults to 22 . :subsystems - a list of SSH subsystems specs to start. Defaults to SFTP and ssh_subsystem_fwup :system_dir - where to find host keys :shell - the language of the shell ( :elixir , :erlang , :lfe , or :disabled ). Defaults to :elixir . :exec - the language to use for commands sent over ssh ( :elixir , :erlang , lfe , or :disabled ). Defaults to :elixir . :iex_opts - additional options to use when starting up IEx :daemon_option_overrides - additional options to pass to :ssh.daemon/2 . These take precedence and are unchecked. Authentication It's possible to set up a number of authentication strategies with the Erlang SSH daemon. Currently, only simple public key and username/password authentication setups are supported by :nerves_ssh . Both of them work fine for getting started. As needs become more sophisticated, you can pass options to :daemon_option_overrides . Public key authentication Public ssh keys can be specified so that matching clients can connect. These come from files like your ~/.ssh/id_rsa.pub or ~/.ssh/id_ecdsa.pub that were created when you created your ssh keys. If you haven't done this, the following article may be helpful. Here's an example that uses the application config: config :nerves_ssh , authorized_keys : [ &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQDBCdMwNo0xOE86il0DB2Tq4RCv07XvnV7W1uQBlOOE0ZZVjxmTIOiu8XcSLy0mHj11qX5pQH3Th6Jmyqdj&quot; , &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQCaf37TM8GfNKcoDjoewa6021zln4GvmOiXqW6SRpF61uNWZXurPte1u8frrJX1P/hGxCL7YN3cV6eZqRiF&quot; ] Here's another way that may work well for you that avoids needing to commit your keys: config :nerves_ssh , authorized_keys : [ File . read! ( Path . join ( System . user_home! , &quot;.ssh/id_rsa.pub&quot; ) ) ] Username/password authentication The SSH console uses public key authentication by default, but it can be configured for usernames and passwords via the :user_passwords key. This has the form [{&quot;username&quot;, &quot;password&quot;}, ...] . Keep in mind that passwords are stored in the clear. This is not recommended for most situations. config :nerves_ssh , user_passwords : [ { &quot;username&quot; , &quot;password&quot; } ] Upgrade from NervesFirmwareSSH If you are migrating from :nerves_firmware_ssh , or updating to :nerves_pack &gt;= 0.4.0 , you will need to make a few changes to your existing project. Generate a upload.sh script by running mix firmware.gen.script (if you don't already have one) This is necessary because you will no longer have access to your old mix upload command because nerves_firmware_ssh is being removed from the project. Change all :nerves_firmware_ssh config values to :nerves_ssh . A command like this would probably do the trick: grep -RIl nerves_firmware_ssh config/ | xargs sed -i &#39;s/nerves_firmware_ssh/nerves_ssh/g&#39; Compile your new firmware that includes :nerves_ssh (or updated :nerves_pack ) NOTE Compiling your new firmware for the first time will generate a warning about the old upload.sh script still being around. You can ignore that this one time because you will need it for uploading to an existing device still using port 8989. Upload your new firmware with :nerves_ssh using the old upload.sh script (or whatever other method you have been using for OTA firmware updates) After the new firmware with :nerves_ssh is on the device, then you'll need to generate the new upload.sh script with mix firmware.gen.script , or see SSHSubsystemFwup for other supported options Goals [X] Support public key authentication [X] Support username/password authentication [ ] Device generated server certificate and key [ ] Device generated username/password","ref":"NervesSSH.html","title":"NervesSSH","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"NervesSSH.html#child_spec/1","title":"NervesSSH.child_spec/1","type":"function"},{"doc":"Read the configuration options","ref":"NervesSSH.html#configuration/0","title":"NervesSSH.configuration/0","type":"function"},{"doc":"Return information on the running ssh daemon. See ssh.daemon_info/1 .","ref":"NervesSSH.html#info/0","title":"NervesSSH.info/0","type":"function"},{"doc":"This module contains helper methods for running commands over SSH","ref":"NervesSSH.Exec.html","title":"NervesSSH.Exec","type":"module"},{"doc":"Run one Elixir command coming over ssh","ref":"NervesSSH.Exec.html#run_elixir/1","title":"NervesSSH.Exec.run_elixir/1","type":"function"},{"doc":"Run one LFE command coming over ssh","ref":"NervesSSH.Exec.html#run_lfe/1","title":"NervesSSH.Exec.run_lfe/1","type":"function"},{"doc":"Defines option for running the SSH daemon. The following fields are available: :authorized_keys - a list of SSH authorized key file string :port - the TCP port to use for the SSH daemon. Defaults to 22 . :subsystems - a list of SSH subsystems specs to start. Defaults to SFTP and ssh_subsystem_fwup :system_dir - where to find host keys :shell - the language of the shell ( :elixir , :erlang , :lfe or :disabled ). Defaults to :elixir . :exec - the language to use for commands sent over ssh ( :elixir , :erlang , or :disabled ). Defaults to :elixir . :iex_opts - additional options to use when starting up IEx :user_passwords - a list of username/password tuples (stored in the clear!) :daemon_option_overrides - additional options to pass to :ssh.daemon/2 . These take precedence and are unchecked.","ref":"NervesSSH.Options.html","title":"NervesSSH.Options","type":"module"},{"doc":"Return :ssh.daemon_options()","ref":"NervesSSH.Options.html#daemon_options/1","title":"NervesSSH.Options.daemon_options/1","type":"function"},{"doc":"Convert keyword options to the NervesSSH.Options","ref":"NervesSSH.Options.html#new/1","title":"NervesSSH.Options.new/1","type":"function"},{"doc":"Go through the options and fix anything that might crash The goal is to make options &quot;always work&quot; since it is painful to debug typo's, etc. that cause the ssh daemon to not start.","ref":"NervesSSH.Options.html#sanitize/1","title":"NervesSSH.Options.sanitize/1","type":"function"},{"doc":"Create a new NervesSSH.Options and fill in defaults","ref":"NervesSSH.Options.html#with_defaults/1","title":"NervesSSH.Options.with_defaults/1","type":"function"},{"doc":"","ref":"NervesSSH.Options.html#t:language/0","title":"NervesSSH.Options.language/0","type":"type"},{"doc":"","ref":"NervesSSH.Options.html#t:t/0","title":"NervesSSH.Options.t/0","type":"type"},{"doc":"NervesSSH Manage an SSH daemon and its subsystems on Nerves devices. It has the following features: Automatic startup of the SSH daemon on initialization Ability to hook the SSH daemon into a supervision tree of your choosing Easy setup of SSH firmware updates for Nerves Easy shell and exec setup for Erlang and Elixir Some protection from easy-to-make mistakes that would cause ssh to not be available","ref":"readme.html","title":"NervesSSH","type":"extras"},{"doc":"This library wraps Erlang/OTP's SSH daemon to make it easier to use reliably with Nerves devices. Most importantly, it makes it possible to segment failures in other OTP applications from terminating the daemon and it recovers from rare scenarios where the daemon terminates without automatically restarting. It can be started automatically as an OTP application or hooked into a supervision tree of your creation. Most Nerves users start it automatically as an OTP application. This is easy, but may be limiting and it requires that you use the application environment. See the following sections for options: Starting as an OTP application If you're using :nerves_pack v0.4.0 or later, you don't need to do anything except verify the :nerves_ssh configuration in your config.exs (see below). If you are not using :nerves_pack , add :nerves_ssh to your mix dependency list: def deps do [ { :nerves_ssh , &quot;~&gt; 0.1.0&quot; , targets : @all_targets } ] end And then include it in :shoehorn 's :init list: config :shoehorn , init : [ :nerves_runtime , :vintage_net , :nerves_ssh ] :nerves_ssh will work if you do not add it to the :init list. However, if your main OTP application stops, OTP may stop :nerves_ssh , and that would make your device inaccessible via SSH. Starting as part of one of your supervision trees If you want to do this, make sure that you do NOT specify :nerves_ssh in your config.exs . The :nerves_ssh key decides whether or not to automatically launch based on this. Then when specifying the children for your supervisor, add NervesSSH like this: { NervesSSH , nerves_ssh_options } The nerves_ssh_options should be a NervesSSH.Options struct. See the Configuration section option fields that you may specify. Calling NervesSSH.Options.with_defaults(my_options_list) to build the nerves_ssh_options value is one way of getting reasonable defaults.","ref":"readme.html#usage","title":"NervesSSH - Usage","type":"extras"},{"doc":"NervesSSH supports the following configuration items: :authorized_keys - a list of SSH authorized key file string :user_passwords - a list of username/password tuples (stored in the clear!) :port - the TCP port to use for the SSH daemon. Defaults to 22 . :subsystems - a list of SSH subsystems specs to start. Defaults to SFTP and ssh_subsystem_fwup :system_dir - where to find host keys :shell - the language of the shell ( :elixir , :erlang , :lfe , or :disabled ). Defaults to :elixir . :exec - the language to use for commands sent over ssh ( :elixir , :erlang , lfe , or :disabled ). Defaults to :elixir . :iex_opts - additional options to use when starting up IEx :daemon_option_overrides - additional options to pass to :ssh.daemon/2 . These take precedence and are unchecked.","ref":"readme.html#configuration","title":"NervesSSH - Configuration","type":"extras"},{"doc":"It's possible to set up a number of authentication strategies with the Erlang SSH daemon. Currently, only simple public key and username/password authentication setups are supported by :nerves_ssh . Both of them work fine for getting started. As needs become more sophisticated, you can pass options to :daemon_option_overrides . Public key authentication Public ssh keys can be specified so that matching clients can connect. These come from files like your ~/.ssh/id_rsa.pub or ~/.ssh/id_ecdsa.pub that were created when you created your ssh keys. If you haven't done this, the following article may be helpful. Here's an example that uses the application config: config :nerves_ssh , authorized_keys : [ &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQDBCdMwNo0xOE86il0DB2Tq4RCv07XvnV7W1uQBlOOE0ZZVjxmTIOiu8XcSLy0mHj11qX5pQH3Th6Jmyqdj&quot; , &quot;ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQCaf37TM8GfNKcoDjoewa6021zln4GvmOiXqW6SRpF61uNWZXurPte1u8frrJX1P/hGxCL7YN3cV6eZqRiF&quot; ] Here's another way that may work well for you that avoids needing to commit your keys: config :nerves_ssh , authorized_keys : [ File . read! ( Path . join ( System . user_home! , &quot;.ssh/id_rsa.pub&quot; ) ) ] Username/password authentication The SSH console uses public key authentication by default, but it can be configured for usernames and passwords via the :user_passwords key. This has the form [{&quot;username&quot;, &quot;password&quot;}, ...] . Keep in mind that passwords are stored in the clear. This is not recommended for most situations. config :nerves_ssh , user_passwords : [ { &quot;username&quot; , &quot;password&quot; } ]","ref":"readme.html#authentication","title":"NervesSSH - Authentication","type":"extras"},{"doc":"If you are migrating from :nerves_firmware_ssh , or updating to :nerves_pack &gt;= 0.4.0 , you will need to make a few changes to your existing project. Generate a upload.sh script by running mix firmware.gen.script (if you don't already have one) This is necessary because you will no longer have access to your old mix upload command because nerves_firmware_ssh is being removed from the project. Change all :nerves_firmware_ssh config values to :nerves_ssh . A command like this would probably do the trick: grep -RIl nerves_firmware_ssh config/ | xargs sed -i &#39;s/nerves_firmware_ssh/nerves_ssh/g&#39; Compile your new firmware that includes :nerves_ssh (or updated :nerves_pack ) NOTE Compiling your new firmware for the first time will generate a warning about the old upload.sh script still being around. You can ignore that this one time because you will need it for uploading to an existing device still using port 8989. Upload your new firmware with :nerves_ssh using the old upload.sh script (or whatever other method you have been using for OTA firmware updates) After the new firmware with :nerves_ssh is on the device, then you'll need to generate the new upload.sh script with mix firmware.gen.script , or see SSHSubsystemFwup for other supported options","ref":"readme.html#upgrade-from-nervesfirmwaressh","title":"NervesSSH - Upgrade from NervesFirmwareSSH","type":"extras"},{"doc":"[X] Support public key authentication [X] Support username/password authentication [ ] Device generated server certificate and key [ ] Device generated username/password","ref":"readme.html#goals","title":"NervesSSH - Goals","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"New features Initial support for using scp to copy files. Not all scp features work, but uploading and downloading individual files does. Thanks to Connor Rigby and Binary Noggin for this feature.","ref":"changelog.html#v0-2-3","title":"Changelog - v0.2.3","type":"extras"},{"doc":"Improvements Fix a deprecation warning on OTP 24.0.1 and later Add support for LFE shells. LFE must be a dependency of your project for this to work.","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"Improvements Raise an error at compile-time if the application environment looks like it's using the :nerves_firmware_ssh key instead of the :nerves_ssh one.","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"This update makes using the application environment optional. If you don't have any settings for :nerves_ssh in your config.exs , :nerves_ssh won't start. You can then add {NervesSSH, your_options} to the supervision tree of your choice.","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]